package cn.bunny.service.service.impl;

import cn.bunny.common.email.utils.MailSender;
import cn.bunny.entity.email.EmailSend;
import cn.bunny.entity.email.EmailSendInit;
import cn.bunny.service.service.EmailService;
import jakarta.mail.MessagingException;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

@Service
@Slf4j
public class EmailServiceImpl implements EmailService {

    /**
     * 发送邮件-简单
     *
     * @param emailSend 邮件消息
     */
    @Override
    public void sendSimpleEmail(EmailSend emailSend) {
        EmailSendInit emailSendInit = new EmailSendInit();
        emailSendInit.setHost("smtp.qq.com");
        emailSendInit.setPort(465);
        emailSendInit.setUsername("3324855376@qq.com");
        emailSendInit.setPassword("axyqbvfuxkdqdaai");
        MailSender mailSender = new MailSender(emailSendInit);
        mailSender.sendSimpleEmail(emailSend);
    }

    /**
     * 发送带附件邮件
     *
     * @param emailSend 邮件消息
     * @return 是否成功
     */
    @Override
    public boolean sendAttachmentEmail(EmailSend emailSend, MultipartFile file) {
        try {
            EmailSendInit emailSendInit = new EmailSendInit();
            emailSendInit.setHost("smtp.qq.com");
            emailSendInit.setPort(465);
            emailSendInit.setUsername("3324855376@qq.com");
            emailSendInit.setPassword("axyqbvfuxkdqdaai");

            MailSender mailSender = new MailSender(emailSendInit);
            mailSender.sendAttachmentEmail(emailSend, file);
            return true;
        } catch (MessagingException e) {
            return false;
        }
    }

    /**
     * 发送富文本邮件
     *
     * @param emailSend 邮件消息
     * @return 是否成功
     */
    @Override
    public boolean sendRich(EmailSend emailSend) {
        try {
            EmailSendInit emailSendInit = new EmailSendInit();
            emailSendInit.setHost("smtp.qq.com");
            emailSendInit.setPort(465);
            emailSendInit.setUsername("3324855376@qq.com");
            emailSendInit.setPassword("axyqbvfuxkdqdaai");

            MailSender mailSender = new MailSender(emailSendInit);
            mailSender.sendRichText(emailSend, true);
            return true;
        } catch (MessagingException e) {
            return false;
        }
    }

    /**
     * 发送带抄送的邮件
     *
     * @param emailSend 邮件消息
     * @param ccParam   抄送人
     */
    @Override
    public boolean sendCC(EmailSend emailSend, String ccParam) {
        // // 创建 MimeMessage 对象用于发送邮件富文本或者附件
        // MimeMessage message = javaMailSender.createMimeMessage();
        // // 创建 MimeMessageHelper
        // MimeMessageHelper helper = new MimeMessageHelper(message, true);
        //
        // // 设置发送人
        // helper.setFrom(emailFrom);
        // // 设置邮件接受者
        // helper.setTo(emailSend.getSendTo());
        // // 设置邮件主题
        // helper.setSubject(emailSend.getSubject());
        // // 设置发送消息 为富文本
        // helper.setText(emailSend.getMessage(), true);
        // // 设置抄送人
        // helper.setCc(ccParam.split(","));
        //
        // // 发送邮件
        // javaMailSender.send(message);
        return false;
    }
}
